package MT::Plugin::AmazonWebService;
;#	MTAmazonWebService - Amazon Web Service
;#	@see http://www.magicvox.net/archive/2005/08312245.php
;#			Programmed by Piroli YUKARINOMIYA
;#			Open MagicVox - http://www.magicvox.net
use strict;
use MT::Template::Context;

;# vOCo^
if (MT->can ('add_plugin'))
{
	require MT::Plugin;
	my $plugin = MT::Plugin->new;
		$plugin->name ('MTAmazonWebService ver 0.01 (Release 831)');
		$plugin->description ('Enable to retrieve the item informations in Amazon.co.jp with Amazon Web Service.');
		$plugin->doc_link ('http://www.magicvox.net/archive/2005/08312245.php');
	MT->add_plugin ($plugin);
}

;# nho^
MT::Template::Context->add_tag (UseAmazonWebService => \&MTUseAmazonWebService);

MT::Template::Context->add_container_tag (AwsAsinSearch => \&MTAwsAsinSearch);
MT::Template::Context->add_container_tag (AwsKeywordSearch => \&MTAwsKeywordSearch);
MT::Template::Context->add_container_tag (AwsCustomerReviews => \&MTAwsCustomerReviews);



MT::Template::Context->add_tag (AwsUrl => \&MTAwsUrl);
MT::Template::Context->add_tag (AwsAsin => \&MTAwsAsin);
MT::Template::Context->add_tag (AwsProductName => \&MTAwsProductName);
MT::Template::Context->add_tag (AwsCatalog => \&MTAwsCatalog);
MT::Template::Context->add_tag (AwsCatalogIconUrl => \&MTAwsCatalogIconUrl);
MT::Template::Context->add_tag (AwsReleaseDate => \&MTAwsReleaseDate);
MT::Template::Context->add_tag (AwsManufacturer => \&MTAwsManufacturer);
MT::Template::Context->add_tag (AwsImageUrlSmall => \&MTAwsImageUrlSmall);
MT::Template::Context->add_tag (AwsImageUrlMedium => \&MTAwsImageUrlMedium);
MT::Template::Context->add_tag (AwsImageUrlLarge => \&MTAwsImageUrlLarge);
MT::Template::Context->add_tag (AwsListPrice => \&MTAwsListPrice);
MT::Template::Context->add_tag (AwsOurPrice => \&MTAwsOurPrice);
MT::Template::Context->add_tag (AwsSalesRank => \&MTAwsSalesRank);
MT::Template::Context->add_tag (AwsAvailability => \&MTAwsAvailability);
MT::Template::Context->add_tag (AwsAvgCustomerRating => \&MTAwsAvgCustomerRating);
MT::Template::Context->add_tag (AwsAvgCustomerRatingImageUrl => \&MTAwsAvgCustomerRatingImageUrl);
MT::Template::Context->add_tag (AwsTotalCustomerReviews => \&MTAwsTotalCustomerReviews);

MT::Template::Context->add_tag (AwsCustomerReviewRating => \&MTAwsCustomerReviewRating);
MT::Template::Context->add_tag (AwsCustomerReviewRatingImageUrl => \&MTAwsCustomerReviewRatingImageUrl);
MT::Template::Context->add_tag (AwsCustomerReviewSummary => \&MTAwsCustomerReviewSummary);
MT::Template::Context->add_tag (AwsCustomerReviewComment => \&MTAwsCustomerReviewComment);


;########################################################################

;### MTUseAmazonWebService
sub MTUseAmazonWebService
{
	'<?php @include ("/home/magicvox/www/include/MTAmazonWebService.php"); ?>'. "\r\n";
}

;# MTAwsAsinSearch
sub MTAwsAsinSearch
{
	my ($ctx, $args, $cond) = @_;

	my $asin = $args->{asin};
	if ($asin =~ m/\<MT.*?\>/ || $asin =~ s/\[(\/?MT(.*?))\]/\<$1\>/g)
	{
		my $builder = $ctx->stash ('builder');
		my $tok = $builder->compile ($ctx, $asin);
		defined ($asin = $builder->build ($ctx, $tok, $cond))
				or return $ctx->error ($builder->errstr);
	}

	my $builder = $ctx->stash ('builder');
	my $tokens = $ctx->stash ('tokens');
	my $out = $builder->build ($ctx, $tokens, $cond);
	return $ctx->error ($builder->errstr)
			unless defined $out;

	my $php = '<?php if (amazonAsinSearch ("'. $asin. '")) { $item = 0; ?>'. "\r\n";
	$php .= $out. '<?php } /*amazonAsinSearch*/ ?>'. "\r\n";
	$php;
}

;# MTAwsKeywordSearch
sub MTAwsKeywordSearch
{
	my ($ctx, $args, $cond) = @_;

	my $catalog = $args->{catalog};
	if (defined ($catalog)
			&& ($catalog =~ m/\<MT.*?\>/ || $catalog =~ s/\[(\/?MT(.*?))\]/\<$1\>/g))
	{
		my $builder = $ctx->stash ('builder');
		my $tok = $builder->compile ($ctx, $catalog);
		defined ($catalog = $builder->build ($ctx, $tok, $cond))
				or return $ctx->error ($builder->errstr);
	}
	my $keyword = $args->{keyword};
	if (defined ($keyword)
			&& ($keyword =~ m/\<MT.*?\>/ || $keyword =~ s/\[(\/?MT(.*?))\]/\<$1\>/g))
	{
		my $builder = $ctx->stash ('builder');
		my $tok = $builder->compile ($ctx, $keyword);
		defined ($keyword = $builder->build ($ctx, $tok, $cond))
				or return $ctx->error ($builder->errstr);
	}
	my $lastn = $args->{lastn};
	if (defined ($lastn)
			&& ($lastn =~ m/\<MT.*?\>/ || $lastn =~ s/\[(\/?MT(.*?))\]/\<$1\>/g))
	{
		my $builder = $ctx->stash ('builder');
		my $tok = $builder->compile ($ctx, $lastn);
		defined ($lastn = $builder->build ($ctx, $tok, $cond))
				or return $ctx->error ($builder->errstr);
	}
	$lastn = 1 if (! defined ($lastn) || $lastn < 1 || 10 < $lastn);

	my $builder = $ctx->stash ('builder');
	my $tokens = $ctx->stash ('tokens');
	my $out = $builder->build ($ctx, $tokens, $cond);
	return $ctx->error ($builder->errstr)
			unless defined $out;

	my $php = '<?php if (amazonKeywordSearch ("'. $catalog. '", "'. $keyword. '"))'. "\r\n";
	$php .= "\t". 'for ($item = 0; $item < '. $lastn. ' && amazonHasResult ($item); $item++) { ?>'. "\r\n";
	$php .= $out. '<?php } /*amazonKeywordSearch*/ ?>'. "\r\n";
	$php;
}

;#MTAwsCustomerReviews
sub MTAwsCustomerReviews
{
	my ($ctx, $args, $cond) = @_;

	my $lastn = $args->{lastn};
	if (defined ($lastn) && ($lastn =~ m/\<MT.*?\>/ || $lastn =~ s/\[(\/?MT(.*?))\]/\<$1\>/g))
	{
		my $builder = $ctx->stash ('builder');
		my $tok = $builder->compile ($ctx, $lastn);
		defined ($lastn = $builder->build ($ctx, $tok, $cond))
				or return $ctx->error ($builder->errstr);
	}
	$lastn = 1 if (! defined ($lastn) || $lastn < 1 || 10 < $lastn);

	my $builder = $ctx->stash ('builder');
	my $tokens = $ctx->stash ('tokens');
	my $out = $builder->build ($ctx, $tokens, $cond);
	return $ctx->error ($builder->errstr)
			unless defined $out;

	my $php = '<?php for ($index = 0; $index < '. $lastn. ' && amazonHasReview ($item, $index); $index++) { ?>'. "\r\n";
	$php .= $out. '<?php } /*MTAwsCustomerReviews*/ ?>'. "\r\n";
	$php;
}

;# MTAws*
sub MTAwsUrl { '<?php print amazonUrl ($item); ?>'; }
sub MTAwsAsin { '<?php print amazonAsin ($item); ?>'; }
sub MTAwsProductName { '<?php print amazonProductName ($item); ?>'; }
sub MTAwsCatalog { '<?php print amazonCatalog ($item); ?>'; }
sub MTAwsCatalogIconUrl { '<?php print amazonCatalogImageUrl ($item); ?>'; }
sub MTAwsReleaseDate { '<?php print amazonReleaseDate ($item); ?>'; }
sub MTAwsManufacturer { '<?php print amazonManufacturer ($item); ?>'; }
sub MTAwsImageUrlSmall { '<?php print amazonImageUrlSmall ($item); ?>'; }
sub MTAwsImageUrlMedium { '<?php print amazonImageUrlMedium ($item); ?>'; }
sub MTAwsImageUrlLarge { '<?php print amazonImageUrlLarge ($item); ?>'; }
sub MTAwsListPrice { '<?php print amazonListPrice ($item); ?>'; }
sub MTAwsOurPrice { '<?php print amazonOurPrice ($item); ?>'; }
sub MTAwsSalesRank { '<?php print amazonSalesRank ($item); ?>'; }
sub MTAwsAvailability { '<?php print amazonAvailability ($item); ?>'; }
sub MTAwsAvgCustomerRating { '<?php print amazonAvgCustomerRating ($item); ?>'; }
sub MTAwsAvgCustomerRatingImageUrl { '<?php print amazonAvgCustomerRatingImageUrl ($item); ?>'; }
sub MTAwsTotalCustomerReviews { '<?php print amazonTotalCustomerReviews ($item); ?>'; }
sub MTAwsCustomerReviewRating { '<?php print amazonCustomerReviewRating ($item, $index); ?>'; }
sub MTAwsCustomerReviewRatingImageUrl { '<?php print amazonCustomerReviewRatingImageUrl ($item, $index); ?>'; }
sub MTAwsCustomerReviewSummary { '<?php print amazonCustomerReviewSummary ($item, $index); ?>'; }
sub MTAwsCustomerReviewComment { '<?php print amazonCustomerReviewComment ($item, $index); ?>'; }



1;
__END__
========================================================================
2005/08/--	0.10	ŌJ
